# i2p-docker-proxy
# Copyright (C) 2019 LoveIsGrief
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
import argparse
import logging
import multiprocessing
import os
import typing
from time import sleep

from i2plib import sam

from trans_proxy import fake_dns
from trans_proxy.process import AsyncProcess
from trans_proxy.servers.client import start_client_tcp_tunnel
from trans_proxy.servers.server import start_server_tcp_tunnel

ENV_PORT = "PROXY_PORT"
ENV_SAM_HOST = "PROXY_SAM_HOST"
ENV_SAM_PORT = "PROXY_SAM_PORT"
ENV_DNS_PORT = "PROXY_DNS_PORT"
ENV_SERVER_ACTIVE = "PROXY_SERVER_ACTIVE"
ENV_SERVER_PORT = "PROXY_SERVER_PORT"
ENV_PRIV_KEY = "PROXY_PRIV_KEY"

logger = logging.getLogger("trans_proxy.cli")


def main():
    # TODO: Write helper formatter that prints default values and env var names
    parser = argparse.ArgumentParser(
        description="Forwards packets to an I2P instance and handles DNS requests"
    )
    parser.add_argument(
        "--verbose",
        action='store_true',
        help="Activates verbose logs")
    parser.add_argument(
        "-p", "--port",
        default=os.environ.get(ENV_PORT, 1234),
        type=int,
        help="Where all traffic should enter to be forwarded")
    parser.add_argument(
        "--sam-host",
        default=os.environ.get(ENV_SAM_HOST, sam.DEFAULT_ADDRESS[0]))
    parser.add_argument(
        "--sam-port",
        type=int,
        default=os.environ.get(ENV_SAM_PORT, sam.DEFAULT_ADDRESS[1]))
    # TODO: provide option to read this from a file (useful for docker secrets)
    parser.add_argument(
        "--priv-key",
        help="Your private key in base64."
             " It is generated by SAM automatically if none is provided."
             " Reuse the generated one to have a stable address on the I2P network",
        default=os.environ.get(ENV_PRIV_KEY)
    )

    dns_group = parser.add_argument_group('dns')
    dns_group.add_argument(
        "--dns-port",
        type=int,
        default=os.environ.get(ENV_DNS_PORT, 1053))

    server_group = parser.add_argument_group('server')
    server_group.add_argument(
        "--server",
        action="store_true",
    )
    server_group.add_argument(
        "--server-port",
        type=int,
        help="The port your app is listening to",
        default=os.environ.get(ENV_SERVER_PORT, 80))

    args = parser.parse_args()

    logging.basicConfig(level=logging.DEBUG if args.verbose else logging.INFO)

    with multiprocessing.Manager() as m:
        ip_dict = m.dict()
        processes = [
            AsyncProcess(
                target=start_client_tcp_tunnel,
                kwargs={
                    "sam_host": args.sam_host,
                    "sam_port": args.sam_port,
                    "ip_dict": ip_dict,
                    "port": args.port,
                }
            ),
            multiprocessing.Process(
                target=fake_dns.main,
                kwargs={
                    "port": args.dns_port,
                    "ip_dict": ip_dict,
                }
            )
        ]

        if args.server or os.getenv(ENV_SERVER_ACTIVE):
            processes.append(AsyncProcess(
                target=start_server_tcp_tunnel,
                kwargs={
                    "sam_host": args.sam_host,
                    "sam_port": args.sam_port,
                    "target_port": args.server_port,
                    "priv_key": args.priv_key,
                }
            ))

        exec_processes(processes)


def exec_processes(processes: typing.List[multiprocessing.Process]):
    """
    Starts processes and waits for them to end
    """
    # TODO: manage processes better
    for process in processes:
        process.start()

    try:
        all_processes_done = False
        while not all_processes_done:
            sleep(1)
            all_processes_done = all(
                not process.is_alive()
                for process in processes
            )
    except KeyboardInterrupt:
        pass
    finally:
        for process in processes:
            if process.is_alive():
                process.kill()


if __name__ == '__main__':
    main()
